// 使用自定义函数解析查询字符串并返回参数对象
function util_getCurrentUrlQueryStringParams() {
    // 获取当前URL的查询字符串部分
    var queryString = window.location.search;
    var params = {};
    // 移除开头的问号
    queryString = queryString.substring(1);
    // 分割成键值对数组
    var keyValuePairs = queryString.split('&');
    // 遍历键值对数组，将每一对分割成键和值，并存入params对象
    keyValuePairs.forEach(function(keyValuePair) {
        var pair = keyValuePair.split('=');
        var key = decodeURIComponent(pair[0]);
        var value = decodeURIComponent(pair[1] || '');
        params[key] = value;
    });
    return params;
}

function util_get_random_number(min=1000, max=5000){
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

function util_currentpage_scrollToBottomWithCallback(callback) {
    //
    var message = {
        action: 'can_zidong_caiji',
        info: ''
    };
    chrome.runtime.sendMessage(message,(msg)=> {
        console.log('can_zidong_caiji 答复', msg)
        let msgobj = JSON.parse(msg);
        console.log(msgobj['state']);
        if (msgobj['state'] == 0) { //可采集
            console.log('can zidong');
            setTimeout(function() {
                callback();
            }, util_get_random_number(5000,10000));
            return;
            //
            var start = window.pageYOffset; // 当前滚动位置
            var end = document.documentElement.scrollHeight - window.innerHeight; // 滚动到底部

            var duration = util_get_random_number(15000,30000); // 8 秒
            var startTime = null;

            function scroll(time) {
                if (!startTime) {
                    startTime = time;
                }
                var progress = (time - startTime) / duration;
                if (progress > 1) {
                    progress = 1;
                }
                var newPosition = start + (end - start) * progress;
                window.scrollTo(0, newPosition);

                if (progress < 1) {
                    requestAnimationFrame(scroll);
                } else {
                    // 滚动完成后执行回调
                    callback();
                    //util_currentpage_scrollToBottomWithCallback();
                }
            }
            requestAnimationFrame(scroll);
            //
        }else{
            console.log('自动翻页采集已暂停');
        }
    });
}

//搜索页采集
function shangjia_search_caiji(){
    var message = {
        action: 'can_zidong_caiji',
        info: ''
    };
    chrome.runtime.sendMessage(message,(msg)=> {
        console.log('can_zidong_caiji 答复', msg)
        let msgobj = JSON.parse(msg);
        console.log(msgobj['state']);
        if (msgobj['state'] == 0) { //可采集
            console.log('shangjia_search_caiji');
            let current_url = window.location.href;
            if(current_url) {
                if (1 || current_url.indexOf('search') != -1) {
                    var shangjia_infos = [];
                    console.log('shangjia_search_caiji a2');
                    $(".opbox-listing article").each(function (){
                        //console.log('shangjia_search_caiji a3');
                        let _shangjia_name = '';
                        let _shangjia_img = '';
                        let _shangjia_a_link = $(this).find('a').eq(0).attr('href');
                        if(_shangjia_a_link){
                            let _shangjia_a_link_www = _shangjia_a_link;
                            let _shangjia_id = _shangjia_a_link;

                            let _shangjia_info = {
                                '_shangjia_id': _shangjia_id,
                                '_shangjia_name': '',
                                '_shangjia_a_link':_shangjia_a_link_www,
                            };
                            //console.log(_shangjia_info);
                            shangjia_infos.push(_shangjia_info);
                            //
                        }
                    });
                    //
                    var message = {
                        action: 'shangjia_items_update',
                        info: '',
                        shangjia_infos: shangjia_infos
                    };
                    send_message_to_popup(message);
                    //
                     //
                    console.log('zidong caiji');
                   // let next_page = $("div[data-role='paginationBottom'] a[data-role='next-page']").attr('href');
                    //console.log('next_page:'+next_page);
                    let now_url = current_url;
                    let params = util_getCurrentUrlQueryStringParams();
                    console.log('params');
                    console.log(params);
                    let next_page_num = 2;
                    let other_agrs = '';
                    if(params){
                        if(params.hasOwnProperty('p')){
                            let p = params['p'];
                            p = parseInt(p);
                            next_page_num = p+1;
                        }
                        for (let param_key in params) {
                            if(param_key !='p'){
                                other_agrs +=param_key+'='+params[param_key]+'&';
                            }
                        }
                        if(other_agrs){
                            other_agrs = other_agrs.slice(0,-1);
                            other_agrs +='&p='+next_page_num;
                        }else{
                            other_agrs = 'p='+next_page_num;
                        }
                    }
                    //
                    let max_page_num = $("div[data-role='paginationBottom'] div[role='navigation'] span.mvrt_8").text();
                    if(max_page_num){
                        max_page_num = parseInt(max_page_num);
                    }else{
                        max_page_num = 0;
                    }
                    console.log('max_page_num');
                    console.log(max_page_num);

                    console.log('next_page_num');
                    console.log(next_page_num);
                    //
                    if(next_page_num < max_page_num){
                        let now_url_arr = now_url.split('?');
                        let next_page_url = now_url_arr[0]+'?'+other_agrs;
                        console.log('next_page_url');
                        console.log(next_page_url);

                        setTimeout(function() {
                         location.href = next_page_url;
                        }, util_get_random_number(5000,10000));
                    }

                    //
                    //util_currentpage_scrollToBottomWithCallback(function (){

                   // });
                    //
                }
            }
        }else{
            console.log('已暂停自动采集');
        }
    });
}


var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
        if(performanceResourceItem['initiatorType'] == 'xmlhttprequest'){
            if(performanceResourceItem['name'].indexOf('p=')!=-1
                && performanceResourceItem['name'].indexOf('allegro')!=-1
                && performanceResourceItem['name'].indexOf('doubleclick') == -1
                && performanceResourceItem['name'].indexOf('google-analytics') == -1
                && performanceResourceItem['name'].indexOf('ngacm') == -1){
                //console.log(performanceResourceItem['name']);
                console.log('bbbb'+performanceResourceItem['name']);
                //
                setTimeout(function() {
                   // shangjia_search_caiji();
                }, 2000);
            }else if(performanceResourceItem['name'].indexOf('p=')!=-1 && performanceResourceItem['name'].indexOf('listingId')!=-1){
                console.log('aaaa'+performanceResourceItem['name']);
                setTimeout(function() {
                    //shangjia_search_caiji();
                }, 2000);
            }
        }
    }
    //////
    /*performanceNavigationList = list.getEntriesByType('navigation');
    for(i = 0; i<performanceNavigationList.length; i++) {
        performanceNavigationItem = performanceNavigationList[i];
        if (performanceNavigationItem['initiatorType'] == 'navigation') {
            navigation_url = performanceNavigationItem['name']
        }
    }*/
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});
//observer_.observe({entryTypes:['resource', 'navigation', 'paint']});
//

$(document).ready(function () {
    let current_url = window.location.href;
    if(current_url && (current_url.indexOf('kategoria') != -1
        || current_url.indexOf('listing') !=-1
        || current_url.indexOf('uzytkownik') !=-1)) {
        setTimeout(function() {
            shangjia_search_caiji();
            }, 1000);
    }
});

//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        //
         if(message.shangjia_infos.length > 0){
            //alert('该页卖家已成功添加到采集队列');
         }
        //
        console.log('答复',msg)
    })
}
//
function downloadIamge(imgsrc, name){//下载图片地址和图片名
    let image = new Image();
    // 解决跨域 Canvas 污染问题
    image.setAttribute("crossOrigin", "anonymous");
    image.onload = function() {
        let canvas = document.createElement("canvas");
        canvas.width = image.width;
        canvas.height = image.height;
        let context = canvas.getContext("2d");
        context.drawImage(image, 0, 0, image.width, image.height);
        let url = canvas.toDataURL("image/jpeg"); //得到图片的base64编码数据
        let a = document.createElement("a"); // 生成一个a元素
        let event = new MouseEvent("click"); // 创建一个单击事件
        a.download = name || "photo"; // 设置图片名称
        a.href = url; // 将生成的URL设置为a.href属性
        a.dispatchEvent(event); // 触发a的单击事件
    }
    image.src = imgsrc;
}
//
function get_product_lunbo_imgs(){
    console.log('aaaa');
    //图片列表
    $('._2AOclWz7 ._3ACovDZO').each(function (){
        var _img = $(this).find('img').attr('src');
        if(_img.indexOf("?") !== -1){
            var _imgarr = _img.split('?')
            _img = _imgarr[0];
            //
            _img_src = _img;
            var _imgarr = _img.split('/')
            _img_name = _imgarr[_imgarr.length-1]
            _img_name_arr = _img_name.split('.')
            _img_name = _img_name_arr[0]
            //
            downloadIamge(_img_src,_img_name);
        }

    })
    //
}
//
function get_product_details_imgs(){
    console.log('aaaa');
    //
    $('._151rnt-L').find('img').each(function (){
        var _detail_img = $(this).attr('src');
        if(_detail_img.indexOf("?") !== -1){
            var _detail_imgarr = _detail_img.split('?')
            _detail_img = _detail_imgarr[0];
            //
            _img_src = _detail_img;
            var _imgarr = _detail_img.split('/')
            _img_name = _imgarr[_imgarr.length-1]
            _img_name_arr = _img_name.split('.')
            _img_name = _img_name_arr[0]
            //
            downloadIamge(_img_src,_img_name);
        }

    })

}
//
// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    if(request.action == 'extract-product-lunbo-imgs'){
        console.log(request.info);
        catalog_products_url = get_product_lunbo_imgs();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract-product-details-imgs'){
        console.log(request.info);
        catalog_products_url = get_product_details_imgs();
        sendResponse(catalog_products_url);
    }
})
//